# 
# patch "apps/app_record.c"
#  from [99690cbcff11be8500a34ddf9b94953592a298f3]
#    to [98c6124bed01a2af4f86f6a7bacca9ab6531e0f5]
# 
===============================================
--- apps/app_record.c	99690cbcff11be8500a34ddf9b94953592a298f3
+++ apps/app_record.c	98c6124bed01a2af4f86f6a7bacca9ab6531e0f5
@@ -78,9 +78,8 @@
 	int dspsilence = 0;
 	int silence = 0;		/* amount of silence to allow */
 	int gotsilence = 0;		/* did we timeout for silence? */
-	int maxduration = 0;		/* max duration of recording */
+	int maxduration = 0;		/* max duration of recording in milliseconds */
 	int gottimeout = 0;		/* did we timeout for maxduration exceeded? */
-	time_t timeout = 0;
 	int option_skip = 0;
 	int option_noanswer = 0;
 	int option_append = 0;
@@ -131,7 +130,8 @@
 	
 	if (maxstr) {
 		if ((sscanf(maxstr, "%d", &i) == 1) && (i > -1))
-			maxduration = i;
+			/* Convert duration to milliseconds */
+			maxduration = i * 1000;
 		else if (!ast_strlen_zero(maxstr))
 			ast_log(LOG_WARNING, "'%s' is not a valid maximum duration\n", maxstr);
 	}
@@ -218,13 +218,18 @@
 		
 		
 		if (s) {
-			if (maxduration > 0)
-				timeout = time(NULL) + (time_t)maxduration;
+			int waitres;
+
+			if (maxduration <= 0)
+				maxduration = -1;
 			
-			while (ast_waitfor(chan, -1) > -1) {
-				if (maxduration > 0 && time(NULL) > timeout) {
-					gottimeout = 1;
-					break;
+			while ((waitres = ast_waitfor(chan, maxduration)) > -1) {
+				if (maxduration > 0) {
+					if (waitres == 0) {
+						gottimeout = 1;
+						break;
+					}
+					maxduration = waitres;
 				}
 				
 				f = ast_read(chan);
